"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createInternalTx = exports.getNetworkFee = exports.validateAddress = exports.getTransactionLink = exports.getExplorerLink = exports.importRecoveryPhrase = exports.generateAddress = exports.formatValue = exports.config = void 0;
const crypto_1 = require("@solar-network/crypto");
const bip39 = __importStar(require("bip39"));
const bignumber_js_1 = __importDefault(require("bignumber.js"));
// Utils
const api_1 = require("../../utils/api");
exports.config = {
    coins: ['sxp'],
    wordsSize: [12],
    isWithPhrase: true,
    isInternalTx: true,
    extraIdName: 'Memo',
};
const ten8 = new bignumber_js_1.default(10).pow(8);
const { pubKeyHash } = crypto_1.Networks.mainnet.network;
const formatValue = (value, type) => {
    if (type === 'from') {
        return Number(new bignumber_js_1.default(value).div(ten8));
    }
    return Number(new bignumber_js_1.default(value).multipliedBy(ten8));
};
exports.formatValue = formatValue;
const generateAddress = async () => {
    const mnemonic = bip39.generateMnemonic();
    const { privateKey } = crypto_1.Identities.Keys.fromPassphrase(mnemonic);
    const address = crypto_1.Identities.Address.fromPassphrase(mnemonic, pubKeyHash);
    return {
        address,
        mnemonic,
        privateKey,
    };
};
exports.generateAddress = generateAddress;
const importRecoveryPhrase = async (mnemonic) => {
    const { privateKey } = crypto_1.Identities.Keys.fromPassphrase(mnemonic);
    const address = crypto_1.Identities.Address.fromPassphrase(mnemonic, pubKeyHash);
    return {
        address,
        mnemonic,
        privateKey,
    };
};
exports.importRecoveryPhrase = importRecoveryPhrase;
const getExplorerLink = (address) => {
    return `https://explorer.solar.org/wallets/${address}`;
};
exports.getExplorerLink = getExplorerLink;
const getTransactionLink = (hash) => {
    return `https://explorer.solar.org/transactions/${hash}`;
};
exports.getTransactionLink = getTransactionLink;
const validateAddress = (address) => {
    return crypto_1.Identities.Address.validate(address, pubKeyHash);
};
exports.validateAddress = validateAddress;
const getNetworkFee = async (props) => {
    const { addressFrom, amount, chain } = props;
    return await (0, api_1.getNetworkFeeRequest)(chain, addressFrom, amount);
};
exports.getNetworkFee = getNetworkFee;
const createInternalTx = async (props) => {
    const { mnemonic, addressFrom, addressTo, amount, networkFee, extraId } = props;
    if (!mnemonic) {
        return null;
    }
    crypto_1.Managers.configManager.setFromPreset('mainnet');
    crypto_1.Transactions.TransactionRegistry;
    const nonce = await (0, api_1.getAddressNonce)('sxp', addressFrom);
    const transaction = crypto_1.Transactions.BuilderFactory.transfer()
        .version(3)
        .nonce(nonce)
        .recipientId(addressTo)
        .amount(`${(0, exports.formatValue)(amount, 'to')}`)
        .fee(`${(0, exports.formatValue)(networkFee, 'to')}`)
        .memo(extraId || '')
        .sign(mnemonic)
        .build();
    return await (0, api_1.sendRawTransaction)('', 'sxp', transaction.toJson());
};
exports.createInternalTx = createInternalTx;
